#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/time.h>
#include <pthread.h>

#include "unDriver.h"

#define DEVICENAME "/dev/myDevice3"
#define initVal 1
#define pseudoPeriod 2

static int devID;
static int *pWrite;

struct timeval  timeZero;	// instant de demarrage du simulateur
struct timeval  currentTime; 	// instant courant
struct timezone zone;

void * sendData(void * null)
{	
	int timeWrite;		// instant d'écriture
	int i = 0;

	while (1)
	{
		sleep(pseudoPeriod);		

		*pWrite += 3; // valeur capteur croissante

		// ecriture driver
		write(devID,(char*)pWrite,sizeof(int));

		gettimeofday(&currentTime,&zone);
		timeWrite = currentTime.tv_sec-timeZero.tv_sec;
		printf("ecriture de %i(%i)(%i)\n",*pWrite,i,timeWrite);

		i++;
	
	}
	close(devID);
	pthread_exit(NULL);
}

int main(void)
{

	pthread_t sendDataID;
	int cr;

	// mise a jour valeur initiale capteur
	pWrite= (int*) malloc(sizeof(int));
	*pWrite = initVal;

	devID = open(DEVICENAME,O_RDWR);

	printf("test Driver sur fd = %i\n", devID);

	if (devID>0)
	{
		// memorisation de l'instant de lancement de l'emulateur de capteur
		gettimeofday(&timeZero,&zone); 

		// activation du thread emulant le capteur
		cr = pthread_create(&sendDataID,NULL,sendData,NULL);

		if (cr==0)
		{
			printf("activation capteur ok\n");
		}
		else
		{
			printf("pas d'activation du capteur\n");
		}
	}
	else
	{
		printf("erreur sur l'ouverture du device\n");
	}
	
	pthread_exit(NULL);
}
